#!/usr/bin/python

##   Previews Reader
##   Copyright (C) 2004-2008 Mads Villadsen <maxximum@krakoa.dk>
    
##   This program is free software; you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation; either version 2 of the License, or
##   (at your option) any later version.
   
##   This program is distributed in the hope that it will be useful,
##   but WITHOUT ANY WARRANTY; without even the implied warranty of
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##   GNU General Public License for more details.
   
##   You should have received a copy of the GNU General Public License
##   along with this program; if not, write to the Free Software
##   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import util

class previews_item:
    def __init__(self):
        self.title = ""
        self.itemcode = ""
        self.publisher = ""
        self.pagenumber = ""
        self.price = ""
        self.comment = ""
        self.id = ""
        self.new_series = False

    def set_pagenumber(self, pagenumber):
        self.pagenumber = pagenumber

    def get_pagenumber(self):
        return self.pagenumber

    def set_title(self, title):
        self.title = title

    def get_title(self):
        return self.title

    def set_itemcode(self, itemcode):
        self.itemcode = itemcode

    def get_itemcode(self):
        return self.itemcode

    def set_new_series(self, new):
        self.new_series = new

    def get_new_series(self):
        return self.new_series

    def set_price(self, price):
        self.price = price

    def get_price(self):
        return self.price

    def set_comment(self, comment):
        self.comment = comment

    def get_comment(self):
        return self.comment

    def set_publisher(self, publisher):
        self.publisher = publisher

    def get_publisher(self):
        return self.publisher

    def pretty_print(self):
        print(util.pretty_title(self.title) + " (p. " + self.pagenumber + " - " + self.price + ") " + "\t" + util.pretty_title(self.publisher))

    def pretty_string(self):
        return util.pretty_title(self.title) + " (p. " + self.pagenumber + " - " + self.price + ") " + "\t" + util.pretty_title(self.publisher)

    def pretty_string_no_page(self):
        return util.pretty_title(self.title) + " (" + self.price + ") " + "\t" + util.pretty_title(self.publisher)

    def pretty_string_no_publisher(self):
        return util.pretty_title(self.title) + " (p. " + self.pagenumber + " - " + self.price + ")"

