#!/usr/bin/python

##   Previews Reader
##   Copyright (C) 2004-2008 Mads Villadsen <maxximum@krakoa.dk>
    
##   This program is free software; you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation; either version 2 of the License, or
##   (at your option) any later version.
   
##   This program is distributed in the hope that it will be useful,
##   but WITHOUT ANY WARRANTY; without even the implied warranty of
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##   GNU General Public License for more details.
   
##   You should have received a copy of the GNU General Public License
##   along with this program; if not, write to the Free Software
##   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import string, re
import previews_item

def pretty_title (raw):
    raw = string.capwords(raw)

    # Certain "words" should be all caps, for instance TP, T/S, MED, LG, XL,
    # XXL, O/A, HC, (A), DC, AD, (MR), (C:.
    # This is quite nasty but it makes the output look so much nicer
    raw = string.replace(raw, "Tp", "TP")
    raw = string.replace(raw, "T/s", "T/S")
    raw = string.replace(raw, "Lg", "LG")
    raw = string.replace(raw, "Xl", "XL")
    raw = string.replace(raw, "Xxl", "XXL")
    raw = string.replace(raw, "(o/a)", "(O/A)")
    raw = string.replace(raw, "Hc", "HC")
    raw = string.replace(raw, "(a)", "(A)")
    raw = string.replace(raw, "Dc", "DC")
    raw = string.replace(raw, "2000 Ad", "2000 AD")
    raw = string.replace(raw, "(mr)", "(MR)")
    raw = string.replace(raw, "(c:", "(C:")

    raw = string.replace(raw, "-f", "-F")
    raw = string.replace(raw, "-g", "-G")
    raw = string.replace(raw, "-m", "-M")

    raw = string.replace(raw, "(res)", "(RES)")
    raw = string.replace(raw, "Srp:", "SRP:")
    raw = string.replace(raw, "Nyx ", "NYX ")
    raw = string.replace(raw, "Bprd ", "BPRD ")
    raw = string.replace(raw, "Ac ", "AC ")

    raw = string.replace(raw, "(star", "(STAR")
    raw = string.replace(raw, "(jan", "(JAN")
    raw = string.replace(raw, "(feb", "(FEB")
    raw = string.replace(raw, "(mar", "(MAR")
    raw = string.replace(raw, "(apr", "(APR")
    raw = string.replace(raw, "(may", "(MAY")
    raw = string.replace(raw, "(jun", "(JUN")
    raw = string.replace(raw, "(jul", "(JUL")
    raw = string.replace(raw, "(aug", "(AUG")
    raw = string.replace(raw, "(sep", "(SEP")
    raw = string.replace(raw, "(oct", "(OCT")
    raw = string.replace(raw, "(nov", "(NOV")
    raw = string.replace(raw, "(dec", "(DEC")

    raw = string.replace(raw, "Nhl", "NHL")
    raw = string.replace(raw, "Cd", "CD")
    raw = string.replace(raw, "Dvd", "DVD")
    raw = string.replace(raw, "Jla", "JLA")
    raw = string.replace(raw, "Jsa", "JSA")

    raw = string.replace(raw, "Xiv", "XIV")

    return raw

def get_orderform_items (orderform, newseries):
	f = open (orderform)
	item_strings = f.readlines()
	f.close()
	
        new_item_strings = ""
        try:
            f = open (newseries)
            new_item_strings = f.readlines()
            f.close()
        except:
            # TODO: show this error in the statusbar of the main window
            # print "Unable to load " + newseries
            pass

        new_item_list = []
        new_item_txt_re = re.compile("^[^\t]*\t([^\t]*)")
        new_item_htm_re = re.compile("([A-Z][A-Z][A-Z][0-9][0-9][0-9][0-9][0-9][0-9])")
        for i in new_item_strings:
            new_item_match = new_item_txt_re.search(i)
            if (new_item_match != None):
                new_item_list.append(new_item_match.group(1))
            new_item_match = new_item_htm_re.search(i)
            if (new_item_match != None):
                new_item_list.append(new_item_match.group(1))
            
	
	previews_item_list = []
	pagenumber_re = re.compile("^PAGE ([0-9]*)")
	pagenumber = "0"
	item_re = re.compile("^([^\t]*)\t([A-Z][A-Z][A-Z][0-9][0-9][ ]?[0-9][0-9][0-9][0-9])\t([^\t]*)\t([^\t]*)\t")
        # the order form format was changed in December 2008 to include an extra date field before the price
	item_new_re = re.compile("^([^\t]*)\t([A-Z][A-Z][A-Z][0-9][0-9][ ]?[0-9][0-9][0-9][0-9])\t*([^\t]*)\t([^\t]*)\t([^\t]*)\t([^\t]*)\t([^\t]*)")
	publisher = ""
	for i in item_strings:
                pi = None
		pagenumber_match = pagenumber_re.search(i)
		if (pagenumber_match != None):
			pagenumber = pagenumber_match.group(1)

                item_match = item_new_re.search(i)
                if (item_match != None):
                    # Create new previews item according to the new structure of the order form
                    pi = previews_item.previews_item()

                    pi.set_pagenumber(unicode(pagenumber, "cp1252"))
                    pi.set_comment(unicode(item_match.group(1), "cp1252"))
                    pi.set_itemcode(unicode(item_match.group(2), "cp1252"))
                    pi.set_title(unicode(item_match.group(3), "cp1252"))
                    pi.set_price(unicode(item_match.group(5), "cp1252"))
                    pi.set_publisher(unicode(publisher, "cp1252"))

                else:
                    item_match = item_re.search(i)
                    if (item_match != None):
                        # Create new previews item according to the old structure of the order form
			pi = previews_item.previews_item()

			pi.set_pagenumber(unicode(pagenumber, "cp1252"))
			pi.set_comment(unicode(item_match.group(1), "cp1252"))
			pi.set_itemcode(unicode(item_match.group(2), "cp1252"))
			pi.set_title(unicode(item_match.group(3), "cp1252"))
			pi.set_price(unicode(item_match.group(4), "cp1252"))
			pi.set_publisher(unicode(publisher, "cp1252"))

                if (pi != None):
                    if (len(new_item_list) > 0):
                        pi.set_new_series(string.replace(pi.get_itemcode(), " ", "") in new_item_list)
                    else:
                        # the new items list was empty so we make an educated guess instead
                        if (pi.get_title().find("#1 ") > 0 or pi.get_title().endswith("#1")):
                            pi.set_new_series(True)
                    previews_item_list.append(pi)


		if (item_match == None and pagenumber_match == None and not(string.find(i, "(") == 0)):
                    # if it starts with ( it is probably just a comment, and not a publisher after all
                    publisher = string.strip(i)
	
	return previews_item_list

def get_previews_data(basename):
    previews_string = ""

    try:
        f = open (basename + "-adult.txt")
        previews_string += f.read()
        f.close()
    except:
        # TODO: show this error in the statusbar of the main window
        # print "Unable to load " + basename + "-adult.txt"
        pass

    try:
        f = open (basename + "-marvel.txt")
        previews_string += f.read()
        f.close()
    except:
        # TODO: show this error in the statusbar of the main window
        # print "Unable to load " + basename + "-marvel.txt"
        pass

    try:
        f = open (basename + ".txt")
        previews_string += f.read()
        f.close()
    except:
        # TODO: show this error in the statusbar of the main window
        # print "Unable to load " + basename + ".txt"
        pass

    # cleanup the Previews data
    previews_string = previews_string.replace("\t", "")
    previews_string = previews_string.replace("\r", "")
    return string.split(previews_string, "\n\n")
